import { TokenId, Context } from '../sdklegacy';
import { ChainConfig, TokenConfig } from '../config/types';
import { TokenPrices } from '../store/tokenPrices';
import { Chain, amount as sdkAmount } from '@wormhole-foundation/sdk';
export declare const MAX_DECIMALS = 6;
export declare const NORMALIZED_DECIMALS = 8;
export declare function convertAddress(address: string): string;
export declare function trimAddress(address: string, max?: number): string;
export declare function trimTxHash(txHash: string, headLength?: number, tailLength?: number): string;
export declare function displayAddress(chain: Chain, address: string): string;
export declare function displayWalletAddress(walletType: Context | undefined, address: string): string;
export declare function getChainByChainId(chainId: number | string): ChainConfig | undefined;
export declare function getChainConfig(chain: Chain): ChainConfig;
export declare function getWrappedToken(token: TokenConfig): TokenConfig;
export declare function getWrappedTokenId(token: TokenConfig): TokenId;
export declare function getTokenById(tokenId: TokenId): TokenConfig | undefined;
export declare function getDisplayName(token: TokenConfig, chain: Chain): string;
export declare function getGasToken(chain: Chain): TokenConfig;
export declare function getTokenDecimals(chain: Chain, token: TokenConfig): number;
export declare function copyTextToClipboard(text: string): boolean;
export declare function hexPrefix(hex: string): string;
export declare function isValidTxId(chain: Chain, tx: string): boolean;
export declare function usePrevious<T>(value: T): T | undefined;
export declare function sleep(timeout: number): Promise<unknown>;
export declare function hydrateHrefTemplate(href: string, fromChain?: string, toChain?: string): string;
export declare function isEqualCaseInsensitive(a: string, b: string): boolean;
export declare const sortTokens: (tokens: TokenConfig[], chain: Chain) => TokenConfig[];
export declare const getTokenPrice: (tokenPrices: TokenPrices, token: TokenConfig) => number | undefined;
export declare const getUSDFormat: (price: number | undefined) => string;
export declare const calculateUSDPriceRaw: (amount?: sdkAmount.Amount | number, tokenPrices?: TokenPrices | null, token?: TokenConfig) => number | undefined;
export declare const calculateUSDPrice: (amount?: sdkAmount.Amount | number, tokenPrices?: TokenPrices | null, token?: TokenConfig) => string;
/**
 * Checks whether an object is empty.
 *
 * isEmptyObject(null)
 * // => true
 *
 * isEmptyObject(undefined)
 * // => true
 *
 * isEmptyObject({})
 * // => true
 *
 * isEmptyObject({ 'a': 1 })
 * // => false
 */
export declare const isEmptyObject: (value: object | null | undefined) => boolean;
export declare const getExplorerUrl: (chain: Chain, address: string) => string;
export declare const isFrankensteinToken: (token: TokenConfig, chain: Chain) => boolean;
export declare const isWrappedToken: (token: TokenConfig, chain: Chain) => boolean;
export declare const isCanonicalToken: (token: TokenConfig, chain: Chain) => boolean;
export declare const isStableCoin: (token: TokenConfig) => boolean;
export declare const millisToHumanString: (ts: number) => string;
export declare const millisToRelativeTime: (ts: number) => string;
export declare const formatDuration: (seconds: number) => string;
//# sourceMappingURL=index.d.ts.map