var B = Object.defineProperty;
var S = (i, e, t) => e in i ? B(i, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : i[e] = t;
var a = (i, e, t) => S(i, typeof e != "symbol" ? e + "" : e, t);
import { c9 as f, ca as v, c5 as x, p, cb as I, b2 as w, bw as U, b9 as $, bx as m, s as o, ax as k, q as c, m as h, cc as C, bC as T, V as E, bz as F, k as _, ba as u, cd as W, bf as N } from "./index-C6iaLaJq.mjs";
import { A as O } from "./aptos-2J8A-FZO.mjs";
class Q {
  constructor(e, t, s, n, r = !1) {
    a(this, "transaction");
    a(this, "network");
    a(this, "chain");
    a(this, "description");
    a(this, "parallelizable");
    this.transaction = e, this.network = t, this.chain = s, this.description = n, this.parallelizable = r;
  }
}
const R = [
  { name: "tokenBridgeAddress", ...f },
  { name: "chain", ...v() },
  {
    name: "domainSeparator",
    binary: "bytes",
    custom: x.encode(p),
    omit: !0
  },
  { name: "tokenId", ...f },
  // from https://github.com/aptos-labs/aptos-core/blob/25696fd266498d81d346fe86e01c330705a71465/aptos-move/framework/aptos-framework/sources/account.move#L90-L95
  { name: "domainSeparator", binary: "bytes", custom: new Uint8Array([255]), omit: !0 }
], z = (i) => I(R, i);
class d {
  constructor(e, t, s, n) {
    a(this, "network");
    a(this, "chain");
    a(this, "connection");
    a(this, "contracts");
    a(this, "chainId");
    a(this, "tokenBridgeAddress");
    this.network = e, this.chain = t, this.connection = s, this.contracts = n, this.chainId = w(t);
    const r = n.tokenBridge;
    if (!r)
      throw new Error(`TokenBridge contract Address for chain ${t} not found`);
    this.tokenBridgeAddress = r;
  }
  static async fromRpc(e, t) {
    const [s, n] = await O.chainFromRpc(e), r = t[n];
    if (r.network !== s)
      throw new Error("Network mismatch " + r.network + " !== " + s);
    return new d(s, n, e, r.contracts);
  }
  async isWrappedAsset(e) {
    try {
      return await this.getOriginalAsset(e), !0;
    } catch {
      return !1;
    }
  }
  async getOriginalAsset(e) {
    const t = e.toString().split(p), s = await this.connection.getAccountResource({
      accountAddress: t[0],
      resourceType: `${this.tokenBridgeAddress}::state::OriginInfo`
    });
    if (!s)
      throw U(e.toString());
    const n = $(parseInt(s.token_chain.number)), r = new m(s.token_address.external_address);
    return { chain: n, address: r };
  }
  async getTokenUniversalAddress(e) {
    return new m(o.encode(k(e.toString()), !0));
  }
  async getTokenNativeAddress(e, t) {
    const s = e === this.chain ? await this.getTypeFromExternalAddress(t.toString()) : await this.getAssetFullyQualifiedType({ chain: e, address: t });
    if (!s)
      throw new Error("Invalid asset address.");
    return new c(s);
  }
  async hasWrappedAsset(e) {
    try {
      return await this.getWrappedAsset(e), !0;
    } catch {
    }
    return !1;
  }
  async getWrappedAsset(e) {
    if (h(e.address))
      throw new Error("native asset cannot be a wrapped asset");
    const t = await this.getAssetFullyQualifiedType(e);
    if (!t)
      throw new Error("Invalid asset address.");
    return await this.connection.getAccountResource({
      accountAddress: C(t),
      resourceType: `${this.tokenBridgeAddress}::state::OriginInfo`
    }), T(this.chain, t);
  }
  async isTransferCompleted(e) {
    const s = (await this.connection.getAccountResource({
      accountAddress: this.tokenBridgeAddress,
      resourceType: `${this.tokenBridgeAddress}::state::State`
    })).consumed_vaas.elems.handle;
    try {
      return await this.connection.getTableItem({
        handle: s,
        data: {
          key_type: "vector<u8>",
          value_type: "u8",
          key: `0x${E.Buffer.from(F(e.hash)).toString("hex")}`
        }
      }), !0;
    } catch {
      return !1;
    }
  }
  async getWrappedNative() {
    return T(this.chain, _);
  }
  async *createAttestation(e, t) {
    const s = { chain: this.chain, address: new c(e) }, n = await this.getAssetFullyQualifiedType(s);
    if (!n)
      throw new Error("Invalid asset address.");
    yield this.createUnsignedTx({
      function: `${this.tokenBridgeAddress}::attest_token::attest_token_entry`,
      typeArguments: [n],
      functionArguments: []
    }, "Aptos.AttestToken");
  }
  async *submitAttestation(e, t) {
    yield this.createUnsignedTx({
      function: `${this.tokenBridgeAddress}::wrapped::create_wrapped_coin_type`,
      typeArguments: [],
      functionArguments: [u(e)]
    }, "Aptos.CreateWrappedCoinType");
    const s = await this.getAssetFullyQualifiedType(e.payload.token);
    if (!s)
      throw new Error("Invalid asset address.");
    yield this.createUnsignedTx({
      function: `${this.tokenBridgeAddress}::wrapped::create_wrapped_coin`,
      typeArguments: [s],
      functionArguments: [u(e)]
    }, "Aptos.CreateWrappedCoin");
  }
  async *transfer(e, t, s, n, r) {
    const b = 0n, l = 0n, A = h(s) ? _ : s.toString(), y = t.address.toUniversalAddress().toUint8Array(), g = w(t.chain);
    r ? yield this.createUnsignedTx({
      function: `${this.tokenBridgeAddress}::transfer_tokens::transfer_tokens_with_payload_entry`,
      typeArguments: [A],
      functionArguments: [n, g, y, l, r]
    }, "Aptos.TransferTokensWithPayload") : yield this.createUnsignedTx({
      function: `${this.tokenBridgeAddress}::transfer_tokens::transfer_tokens_entry`,
      typeArguments: [A],
      functionArguments: [n, g, y, b, l]
    }, "Aptos.TransferTokens");
  }
  async *redeem(e, t, s = !0) {
    const n = t.payload.token.chain === this.chain ? await this.getTypeFromExternalAddress(t.payload.token.address.toString()) : await this.getAssetFullyQualifiedType(t.payload.token);
    if (!n)
      throw new Error("Invalid asset address.");
    yield this.createUnsignedTx({
      function: `${this.tokenBridgeAddress}::complete_transfer::submit_vaa_and_register_entry`,
      typeArguments: [n],
      functionArguments: [u(t)]
    }, "Aptos.CompleteTransfer");
  }
  async getAssetFullyQualifiedType(e) {
    return e.chain === this.chain ? W(e.address.toString()) ? e.address.toString() : null : `${d.getForeignAssetAddress(this.chain, this.tokenBridgeAddress, e)}::coin::T`;
  }
  /**
   * Given a hash, returns the fully qualified type by querying the corresponding TypeInfo.
   * @param address Hash of fully qualified type
   * @returns The fully qualified type associated with the given hash
   */
  async getTypeFromExternalAddress(e) {
    try {
      const t = await this.connection.getAccountResource({
        accountAddress: this.tokenBridgeAddress,
        resourceType: `${this.tokenBridgeAddress}::state::State`
      }), { handle: s } = t.native_infos, n = await this.connection.getTableItem({
        handle: s,
        data: {
          key_type: `${this.tokenBridgeAddress}::token_hash::TokenHash`,
          value_type: "0x1::type_info::TypeInfo",
          key: { hash: e }
        }
      });
      return n ? [
        n.account_address,
        String.fromCharCode(...o.decode(n.module_name)),
        String.fromCharCode(...o.decode(n.struct_name))
      ].join(p) : null;
    } catch {
      return null;
    }
  }
  /**
   * Derive the module address for an asset defined by the given origin chain and address.
   * @param tokenBridgeAddress Address of token bridge (32 bytes)
   * @param originChain Chain ID of chain that original asset is from
   * @param originAddress Native address of asset
   * @returns The module address for the given asset
   */
  static getForeignAssetAddress(e, t, s) {
    if (h(s.address))
      throw new Error("Invalid token address");
    const n = z({
      chain: s.chain,
      tokenBridgeAddress: new c(t).toUniversalAddress(),
      tokenId: s.address.toUniversalAddress()
    });
    return o.encode(k(n), !0);
  }
  createUnsignedTx(e, t, s = !1) {
    return new Q(e, this.network, this.chain, t, s);
  }
}
N("Aptos", "TokenBridge", d);
export {
  d as AptosTokenBridge
};
